package com.redhat.thermostat.tools.eclipse.plugin.model;

import java.util.Objects;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name="bundle")
public class Bundle {

    private String name;
    private String version;

    public Bundle() {
        name = null;
        version = null;
    }

    public Bundle(String name, String version) {
        this.name = name;
        this.version = version;
    }

    @XmlElement(name="symbolic-name")
    public String getSymbolicName() {
        return this.name;
    }

    public void setSymbolicName(String name) {
        this.name = name;
    }

    @XmlElement(name="version")
    public String getVersion() {
        return this.version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String toString() {
        return this.name + " (" + this.version + ")";
    }

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Bundle)) {
            return false;
        }
        Bundle other = (Bundle) obj;
        return Objects.equals(this.name, other.name) && Objects.equals(this.version, other.version);
    }

    @Override
    public int hashCode() {
        return Objects.hash(this.name, this.version);
    }
}
