package com.redhat.thermostat.tools.eclipse.plugin.model;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;

@XmlAccessorType(XmlAccessType.NONE)
public class Environments extends ModelObject {

    private static final String CLI = "cli";
    private static final String SHELL = "shell";

    private List<String> environments;

    public Environments() {
        environments = new ArrayList<String>();
    }

    @XmlElement(name="environment")
    public List<String> getEnvironments() {
        return environments;
    }

    public boolean isCli() {
        return environments.contains(CLI);
    }

    public void setCli(boolean newValue) {
        addOrRemoveEnvironment(CLI, newValue);
    }

    public boolean isShell() {
        return environments.contains(SHELL);
    }

    public void setShell(boolean newValue) {
        addOrRemoveEnvironment(SHELL, newValue);
    }

    private void addOrRemoveEnvironment(String name, boolean add) {
        if (add) {
            if (environments.indexOf(name) == -1) {
                environments.add(name);
                firePropertyChange(name, false, true);
            }
        } else { // remove
            if (environments.indexOf(name) != -1) {
                environments.remove(name);
                firePropertyChange(name, true, false);
            }
        }
    }

    @Override
    public String toString() {
        return "Environments: " + environments.toString();
    }
}
